#include "ws.h"
#include "node.h"

#include <GL/gl.h>

typedef void (*DrawableDeformationFunc) (double time,
					 double x, double y,
					 double *deformed_x,
					 double *deformed_y,
					 gpointer data);

typedef struct DrawableNode DrawableNode;
struct DrawableNode
{
    Node			node;

    WsPixmap *			pixmap;

    gboolean			need_new_pixmap;
    gboolean			we_have_a_texture;

    WsDrawable *		drawable;
    GLuint			texture;

    WsRegion *			damaged_region;

    gboolean			viewable;

    DrawableDeformationFunc	deformation_func;
    gpointer			deformation_data;

    GTimer *			timer;
};

DrawableNode *drawable_node_new (WsDrawable *drawable);
void	      drawable_node_unref (DrawableNode *node);
void	      drawable_node_set_viewable (DrawableNode *node,
					  gboolean viewable);
void	      drawable_node_set_deformation_func (DrawableNode *node,
						  DrawableDeformationFunc deformation_func,
						  gpointer data);
						 
