#include <X11/Xutil.h>
#include <X11/X.h>
#include <glib.h>

#include "ws.h"

typedef struct SGCoord SGCoord;
typedef struct SGVertex SGVertex;

/* Window state:
 * 
 *     UNMAPPED_AND_NOTDRAWN
 * 
 *     MAPPED_AND_DRAWN
 *
 */

/* if parent is NULL, create a full scene graph with display and everything,
 * otherwise, just create a subcoordinate system
 *
 * Do we run the whole thing in its own thread?
 *   If yes, what happens when you call API from another one?
 *     Answer may be that we install an idle to be run in the CM thread
 */
SGCoord *sg_coord_new_root (WsWindow *window);
SGCoord *sg_coord_new_local (SGCoord *parent);

SGVertex *sg_vertex_new       (SGCoord  *sg,
			       double    x,
			       double    y);
void      sg_vertex_move      (SGVertex *vertex,
			       int       dx,
			       int       dy);
void      sg_vertex_move_to   (SGVertex *vertex,
			       int       x,
			       int       y);
void      sg_add_drawable     (Window    window,
			       SGVertex *upper_left,
			       SGVertex *upper_right,
			       SGVertex *lower_left,
			       SGVertex *lower_right);
void      sg_window_attach    (Window    window,
			       gint      x,
			       gint      y,
			       SGVertex *vertex);
void      sg_coord_add_window (SGCoord  *sg,
			       SGVertex *v1,
			       SGVertex *v2,
			       SGVertex *v3,
			       SGVertex *v4,
			       WsWindow *window);

/* Makes sure all xid's on other are visible to the sg */
void sg_sync_with_display (SGCoord *sg,
			   Display *other);
