#include "wsint.h"

WsPixmap *
pixmap_new (Ws *ws,
	    XID xid)
{
    WsPixmap *pixmap = g_new0 (WsPixmap, 1);

    pixmap->drawable.ws = ws;
    pixmap->drawable.xid = xid;
    pixmap->drawable.xdamage = None;
    pixmap->drawable.damage_cb = NULL;
    pixmap->drawable.damage_data = NULL;

    g_hash_table_insert (ws->resources, (gpointer)xid, pixmap);

    return pixmap;
}

WsPixmap *
ws_pixmap_new (WsDrawable *drawable,
	       int	   width,
	       int	   height,
	       int	   depth)
{
    Pixmap pixmap;
    Display *xdisplay = drawable->ws->xdisplay;

    pixmap = XCreatePixmap (xdisplay, drawable->xid, width, height, depth);

    return pixmap_new (drawable->ws, drawable->xid);
}


WsPixmap *
_ws_pixmap_ensure (Ws		*ws,
		   XID		 xid)
{
    WsPixmap *pixmap = g_hash_table_lookup (ws->resources, (gpointer)xid);

    if (!pixmap)
	pixmap = pixmap_new (ws, xid);

    return pixmap;
}

void
ws_pixmap_free (WsPixmap *pixmap)
{
    XFreePixmap (pixmap->drawable.ws->xdisplay, pixmap->drawable.xid);
    /* FIXME */
}
