#include "wsint.h"

WsRegion *
ws_region_new (Ws *ws)
{
    WsRegion *region = g_new0 (WsRegion, 1);

    region->ws = ws;
    region->xregion = XFixesCreateRegion (ws->xdisplay, NULL, 0);
    region->ref_count = 1;
    
    return region;
}

void
ws_region_unref (WsRegion *region)
{
    if (--region->ref_count == 0)
    {
	g_free (region);
    }
}

void
ws_region_union (WsRegion *region,
		 WsRegion *other)
{
    XFixesUnionRegion (region->ws->xdisplay,
		       region->xregion,
		       region->xregion,
		       other->xregion);
}
